;;; -*- Mode: Lisp; Package: STELLA; Syntax: COMMON-LISP; Base: 10 -*-

#|--------------------------------------------------------------------------+
 |                                                                          |
 |  COPYRIGHT (C) UNIVERSITY OF SOUTHERN CALIFORNIA, 1997-2000              | 
 |  University of Southern California, Information Sciences Institute       |
 |  4676 Admiralty Way                                                      |
 |  Marina Del Rey, California 90292                                        |
 |                                                                          |
 |  This software was developed under the terms and conditions of Contract  |
 |  No. N00014-94-C-0245 between the Defense Advanced Research Projects     |
 |  Agency and the University of Southern California, Information Sciences  | 
 |  Institute.  Use and distribution of this software is further subject    |
 |  to the provisions of that contract and any other agreements developed   |
 |  between the user of the software and the University of Southern         |
 |  California, Information Sciences Institute.  It is supplied "AS IS",    |
 |  without any warranties of any kind.  It is furnished only on the basis  |
 |  that any party who receives it indemnifies and holds harmless the       |
 |  parties who furnish and originate it against any claims, demands, or    |
 |  liabilities connected with using it, furnishing it to others or         |
 |  providing it to a third party.  THIS NOTICE MUST NOT BE REMOVED FROM    |
 |  THE SOFTWARE, AND IN THE EVENT THAT THE SOFTWARE IS DIVIDED, IT SHOULD  |
 |  BE ATTACHED TO EVERY PART.                                              |
 |                                                                          |
 +--------------------------------------------------------------------------|#

(CL:IN-PACKAGE "STELLA")

;;; Auxiliary variables:

(CL:DEFVAR /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GREATER-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LESS-OR-EQUAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?A NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE-COLLECTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-SET NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GROUP NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STUFF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR-INTERVAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-LOWER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-UPPER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-USER-THING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PHRASE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LEXEME NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMENT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-DOCUMENTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOCUMENTATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ISSUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-EXAMPLE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?E NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IMAGE-URL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?URL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AUTOMATIC-TERM-INTRODUCTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-NAME NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-CODE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SP NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-EVALUATOR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EV NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-CONSTRAINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONSTRAINT-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CP NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-TRUE-DEMON NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-UNKNOWN-DEMON NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-FALSE-DEMON NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB--> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?FUNCTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CONTEXT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-CONTEXT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?P NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TEST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?THEN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ELSE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-OBSERVED-CARDINALITY-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HIDDEN-RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-POLYMORPHIC NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TYPE-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-EVALUATOR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-DESCRIPTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-LOGIC-OBJECT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-MEMBER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PORTION-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-PHRASE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TRANSITIVE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOMAIN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RANGE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NTH-DOMAIN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SLOT-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-KAPPA NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FILLERS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEMBERS NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SETOFALL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERVT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?Q NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<<= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-=>> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=< NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MINCARD NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUBR NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAXCARD NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-NUMERIC-RANGE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INTERVAL NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MINIMUM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MAXIMUM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUBRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUPERRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUBRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUPERRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUBRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUPERRELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EQUIVALENT-RELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EQUIV NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-UNION-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UNION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LENGTH NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MIN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-OF-NUMBERS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAX NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-OF-NUMBERS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM-OF-NUMBERS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-OF-NUMBERS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-VALUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEDIAN NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-OF-NUMBERS-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARITY NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY-COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INVERSERELATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMUTATIVE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYMMETRIC NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFLEXIVE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IRREFLEXIVE NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<=> NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ANTISYMMETRIC NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Z NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYNONYM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TERM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SYNONYM NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ASSERT-SYNONYM-DEMON NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RETRACT-SYNONYM-DEMON NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-<= NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1 NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-FAIL NULL)
(CL:DEFVAR /PL-KERNEL-KB/KWD-PL-KERNEL-KB-FORWARD? NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-TRUE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH-RULE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SOFT-EQ NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SOFT-EQ-RULE NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF-COMPUTATION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-DISJOINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CHEAP-DISJOINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-MUTUALLY-DISJOINT-COLLECTION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COVERING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COVER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DISJOINT-COVERING NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?DISJOINTCOVER NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION1 NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION2 NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-REFUTATION-DISJOINT NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFUTATION-DISJOINT-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP-SPECIALIST NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STARTUP-PL-KERNEL-KB NULL)
(CL:DEFVAR /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-METHOD-STARTUP-CLASSNAME NULL)

;;; Forward declarations:

(CL:DECLAIM (CL:SPECIAL *STARTUP-TIME-PHASE* *MODULE*))

;;; (DEFCLASS INTEGER-INTERVAL ...)

(CL:DEFCLASS /PL-KERNEL-KB/INTEGER-INTERVAL (THING)
  ((/PL-KERNEL-KB/INTERVAL-LOWER-BOUND :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%INTERVAL-LOWER-BOUND)
   (/PL-KERNEL-KB/INTERVAL-UPPER-BOUND :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%INTERVAL-UPPER-BOUND))
  (:DOCUMENTATION "An interval of integers"))

(CL:DEFUN /PL-KERNEL-KB/NEW-INTEGER-INTERVAL ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF
    (CL:MAKE-INSTANCE (CL:QUOTE /PL-KERNEL-KB/INTEGER-INTERVAL)))
   (CL:SETF (%DYNAMIC-SLOTS SELF) (NEW-KEY-VALUE-LIST))
   (CL:SETF (%SURROGATE-VALUE-INVERSE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-UPPER-BOUND SELF) NULL-INTEGER)
   (CL:SETF (/PL-KERNEL-KB/%INTERVAL-LOWER-BOUND SELF) NULL-INTEGER) SELF))

(CL:DEFMETHOD PRIMARY-TYPE ((SELF /PL-KERNEL-KB/INTEGER-INTERVAL))
  /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-INTEGER-INTERVAL-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-LOWER-BOUND)
    (CL:IF SETVALUE?
     (CL:SETF (/PL-KERNEL-KB/%INTERVAL-LOWER-BOUND SELF)
      (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE
      (WRAP-INTEGER (/PL-KERNEL-KB/%INTERVAL-LOWER-BOUND SELF)))))
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-UPPER-BOUND)
    (CL:IF SETVALUE?
     (CL:SETF (/PL-KERNEL-KB/%INTERVAL-UPPER-BOUND SELF)
      (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE
      (WRAP-INTEGER (/PL-KERNEL-KB/%INTERVAL-UPPER-BOUND SELF)))))
   (CL:T
    (CL:IF SETVALUE?
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS SELF) SLOTNAME VALUE NULL)
     (CL:SETQ VALUE (LOOKUP (%DYNAMIC-SLOTS SELF) SLOTNAME)))))
  VALUE)

;;; (DEFCLASS COMPUTED-PROCEDURE ...)

(CL:DEFCLASS /PL-KERNEL-KB/COMPUTED-PROCEDURE (THING)
  ((/PL-KERNEL-KB/PROCEDURE-NAME :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%PROCEDURE-NAME)
   (/PL-KERNEL-KB/PROCEDURE-CODE :ALLOCATION :INSTANCE :ACCESSOR
    /PL-KERNEL-KB/%PROCEDURE-CODE))
  (:DOCUMENTATION "Each instance denotes a programming language 
function that computes some procedure.  The slot 'procedure-name'
provides the name of the procedure.  The slot 'procedure-code'
points directly to the procedure itself.  Both slots are optional;
if neither is supplied, the procedure will be invoked by extracting
its name from the name of the instance."))

(CL:DEFUN /PL-KERNEL-KB/NEW-COMPUTED-PROCEDURE ()
  (CL:LET* ((SELF NULL))
   (CL:SETQ SELF
    (CL:MAKE-INSTANCE (CL:QUOTE /PL-KERNEL-KB/COMPUTED-PROCEDURE)))
   (CL:SETF (%DYNAMIC-SLOTS SELF) (NEW-KEY-VALUE-LIST))
   (CL:SETF (%SURROGATE-VALUE-INVERSE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%PROCEDURE-CODE SELF) NULL)
   (CL:SETF (/PL-KERNEL-KB/%PROCEDURE-NAME SELF) NULL) SELF))

(CL:DEFMETHOD PRIMARY-TYPE ((SELF /PL-KERNEL-KB/COMPUTED-PROCEDURE))
  /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE)

(CL:DEFUN /PL-KERNEL-KB/ACCESS-COMPUTED-PROCEDURE-SLOT-VALUE (SELF SLOTNAME VALUE SETVALUE?)
  (CL:COND
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-NAME)
    (CL:IF SETVALUE? (CL:SETF (/PL-KERNEL-KB/%PROCEDURE-NAME SELF) VALUE)
     (CL:SETQ VALUE (/PL-KERNEL-KB/%PROCEDURE-NAME SELF))))
   ((CL:EQ SLOTNAME
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-CODE)
    (CL:IF SETVALUE?
     (CL:SETF (/PL-KERNEL-KB/%PROCEDURE-CODE SELF) (%WRAPPER-VALUE VALUE))
     (CL:SETQ VALUE
      (WRAP-FUNCTION-CODE (/PL-KERNEL-KB/%PROCEDURE-CODE SELF)))))
   (CL:T
    (CL:IF SETVALUE?
     (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS SELF) SLOTNAME VALUE NULL)
     (CL:SETQ VALUE (LOOKUP (%DYNAMIC-SLOTS SELF) SLOTNAME)))))
  VALUE)

;;; (DEFUN MEMBER-OF-EVALUATOR ...)

(CL:DEFUN /PL-KERNEL-KB/MEMBER-OF-EVALUATOR (SELF)
  (CL:LET*
   ((VALUE1
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       0)))
    (VALUE2
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       1))))
   (CL:WHEN
    (CL:AND (ISA? VALUE2 /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-DESCRIPTION)
     (ISA? VALUE1 /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-LOGIC-OBJECT)
     (CL:NOT (NAMED-DESCRIPTION? VALUE2)))
    (INHERIT-UNNAMED-DESCRIPTION VALUE1 VALUE2 (DEFAULT-TRUE? SELF)))))

;;; (DEFUN (ARITY-COMPUTATION INTEGER-WRAPPER) ...)

(CL:DEFUN /PL-KERNEL-KB/ARITY-COMPUTATION (DESCRIPTIONARG)
  (CL:LET* ((DESCRIPTION (VALUE-OF DESCRIPTIONARG)))
   (CL:IF (CL:NOT (CL:EQ DESCRIPTION NULL))
    (CL:COND
     ((SUBTYPE-OF? (SAFE-PRIMARY-TYPE DESCRIPTION)
       /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-DESCRIPTION)
      (CL:PROGN (WRAP-INTEGER (ARITY DESCRIPTION))))
     (CL:T NULL))
    NULL)))

;;; (DEFUN ASSERT-SYNONYM-DEMON ...)

(CL:DEFUN /PL-KERNEL-KB/ASSERT-SYNONYM-DEMON (SELF)
  (CL:LET*
   ((VALUE1
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       0)))
    (VALUE2
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       1)))
    (SURROGATE2 NULL))
   (CL:WHEN
    (ISA? VALUE2 /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-LOGIC-OBJECT)
    (CL:SETQ SURROGATE2 (%SURROGATE-VALUE-INVERSE VALUE2))
    (CL:SETF (%SURROGATE-VALUE SURROGATE2) VALUE1))))

;;; (DEFUN RETRACT-SYNONYM-DEMON ...)

(CL:DEFUN /PL-KERNEL-KB/RETRACT-SYNONYM-DEMON (SELF)
  (CL:LET*
   ((VALUE1
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       0)))
    (VALUE2
     (VALUE-OF
      (CL:AREF (CL:THE CL:SIMPLE-VECTOR (%THE-ARRAY (%ARGUMENTS SELF)))
       1)))
    (SURROGATE2 NULL))
   (CL:WHEN
    (ISA? VALUE2 /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-LOGIC-OBJECT)
    (CL:SETQ SURROGATE2 (%SURROGATE-VALUE-INVERSE VALUE2))
    (CL:SETF (%SURROGATE-VALUE SURROGATE2) VALUE1))))

;;; (DEFUN (CONTEXT-OF-COMPUTATION CONTEXT) ...)

(CL:DEFUN /PL-KERNEL-KB/CONTEXT-OF-COMPUTATION (INSTANCE)
  (HOME-MODULE INSTANCE))

;;; (DEFUN INITIALIZE-MODULES ...)

(CL:DEFUN /PL-KERNEL-KB/INITIALIZE-MODULES ()
  (CL:LET* ((MDL NULL) (ITER-000 (ALL-MODULES)))
   (CL:LOOP WHILE (NEXT? ITER-000) DO (CL:SETQ MDL (%VALUE ITER-000))
    (INTRODUCE-MODULE MDL))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB1 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-CLASS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLASS" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLASS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?X" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DOCUMENTATION" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SET" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FUNCTION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?R" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GREATER-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GREATER-OR-EQUAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LESS-OR-EQUAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LESS-OR-EQUAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ABSTRACT"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DUPLICATE-FREE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ARITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VARIABLE-ARITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLOSED" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SINGLE-VALUED" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ORDERED" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUBSET-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COLLECT-INTO-LIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LENGTH-OF-LIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AGGREGATE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?A
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?A" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COLLECTION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?C" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AXIOMS" NULL 2))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE-COLLECTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DUPLICATE-FREE-COLLECTION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=>>" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?S" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-SET
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMERIC-SET" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IFF" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMBER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?L" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GROUP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GROUP" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STUFF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STUFF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SCALAR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR-INTERVAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SCALAR-INTERVAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER-INTERVAL" NULL 1))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-LOWER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-LOWER-BOUND" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-UPPER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTERVAL-UPPER-BOUND" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER-INTERVAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-USER-THING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "USER-THING"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PHRASE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PHRASE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STRING"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LEXEME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LEXEME" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMENT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMMENT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-DOCUMENTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DOCUMENTATION"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=>" NULL 2))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOCUMENTATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DOCUMENTATION-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ISSUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ISSUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-EXAMPLE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EXAMPLE"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?E
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?E" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IMAGE-URL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IMAGE-URL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?URL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?URL" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AUTOMATIC-TERM-INTRODUCTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AUTOMATIC-TERM-INTRODUCTION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTED-PROCEDURE" NULL 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-NAME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROCEDURE-NAME" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROCEDURE-CODE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROCEDURE-CODE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTED-PROCEDURE" NULL 0))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB2 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SP" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-EVALUATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-EVALUATOR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EV
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?EV" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-COMPUTATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?COMPUTATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTATION-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-CONSTRAINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-CONSTRAINT" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONSTRAINT-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HANDLES-REVERSE-POLARITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?CP" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-TRUE-DEMON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GOES-TRUE-DEMON" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-UNKNOWN-DEMON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GOES-UNKNOWN-DEMON" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-FALSE-DEMON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "GOES-FALSE-DEMON" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COLLECTIONOF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?M" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
    (INTERN-RIGID-SYMBOL-WRT-MODULE "->" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SETOF"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "AND"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TOTAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LISTOF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HOLDS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?ARGUMENTS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HOLDS-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?FUNCTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?FUNCTION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VALUE-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CONTEXT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?CONTEXT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-CONTEXT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTEXT"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?P
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?P" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROPOSITION"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IST-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CUT" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CUT-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
    (INTERN-RIGID-SYMBOL-WRT-MODULE "BOUND-VARIABLES" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "BOUND-VARIABLES-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FORK" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TEST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?TEST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?THEN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?THEN" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ELSE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?ELSE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FORK-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-OBSERVED-CARDINALITY-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OBSERVED-CARDINALITY-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?CARD" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INTEGER"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HIDDEN-RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HIDDEN-RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-POLYMORPHIC
    (INTERN-RIGID-SYMBOL-WRT-MODULE "POLYMORPHIC" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INSTANCE-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "THING"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INSTANCE-OF-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TYPE-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TYPE-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<<=>>" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "INVERSE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUB" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUPER"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUBSET-OF-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEMBER-OF" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEMBER-OF-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-EVALUATOR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEMBER-OF-EVALUATOR" NULL 0))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB3 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-DESCRIPTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DESCRIPTION"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/SGT-PL-KERNEL-KB-LOGIC-LOGIC-OBJECT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LOGIC-OBJECT"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 1))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-MEMBER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HAS-MEMBER" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PORTION-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PORTION-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?Y" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-PHRASE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PHRASE" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TRANSITIVE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TRANSITIVE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOMAIN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DOMAIN" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?D" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=>"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?I" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?V" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RANGE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RANGE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NTH-DOMAIN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NTH-DOMAIN" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<=>"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "BINARY-RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SLOT-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SLOT-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLOSED-SPECIALIST" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SINGLE-VALUED-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EMPTY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EMPTY-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMPUTED" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
    (INTERN-RIGID-SYMBOL-WRT-MODULE "THE-ROLESET" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?RS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=" (GET-STELLA-MODULE "/STELLA" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-KAPPA
    (INTERN-RIGID-SYMBOL-WRT-MODULE "KAPPA"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FILLERS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FILLERS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEMBERS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MEMBERS" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<<=" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SETOFALL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SETOFALL"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SET-CARDINALITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FRAME-PREDICATE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VALUE-TYPE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?TYPE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EXISTS"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "OR"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FORALL"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUPERR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERVT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUPERVT" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VALUE-TYPE-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CARDINALITY"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?Q
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?Q" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<<=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<<="
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINIMUM-CARDINALITY" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MAXIMUM-CARDINALITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-=>>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=>>"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CARDINALITY-LOWER-BOUND" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?LB" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
    (INTERN-RIGID-SYMBOL-WRT-MODULE "=<"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
    (INTERN-RIGID-SYMBOL-WRT-MODULE ">="
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINIMUM-CARDINALITY-SPECIALIST" NULL
     0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CARDINALITY-UPPER-BOUND" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?UB" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MAXIMUM-CARDINALITY-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MINCARD
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MINCARD" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MAXIMUM-VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUBR
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUBR" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAXCARD
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MAXCARD" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINIMUM-VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-NUMERIC-RANGE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SET-NUMERIC-RANGE" NULL 0))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB4 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INTERVAL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?INTERVAL" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MINIMUM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMERIC-MINIMUM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?N" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MAXIMUM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NUMERIC-MAXIMUM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUBRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DIRECT-SUBRELATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RELATION-HIERARCHY-SPECIALIST" NULL
     0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUPERRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DIRECT-SUPERRELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUBRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUBRELATION"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUPERRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUPERRELATION"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUBRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROPER-SUBRELATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUPERRELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROPER-SUPERRELATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EQUIVALENT-RELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "EQUIVALENT-RELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EQUIV
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?EQUIV" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-UNION-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "UNION-OF" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UNION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?UNION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COLLECT-INTO-LIST-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LENGTH
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?LENGTH" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "LENGTH-OF-LIST-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MIN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MIN" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-OF-NUMBERS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MINIMUM-OF-NUMBERS-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAX
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MAX" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-OF-NUMBERS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MAXIMUM-OF-NUMBERS-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SUM" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM-OF-NUMBERS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SUM-OF-NUMBERS-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROJECT-COLUMN" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PROJECT-COLUMN-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEAN-VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MEAN" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-OF-NUMBERS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEAN-OF-NUMBERS-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-VALUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEDIAN-VALUE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEDIAN
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?MEDIAN" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-OF-NUMBERS-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MEDIAN-OF-NUMBERS-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STANDARD-DEVIATION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STANDARD-DEVIATION-SPECIALIST" NULL
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VARIANCE" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "VARIANCE-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARITY
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?ARITY" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY-COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ARITY-COMPUTATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INVERSERELATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?INVERSERELATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMUTATIVE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COMMUTATIVE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYMMETRIC
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SYMMETRIC" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFLEXIVE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "REFLEXIVE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IRREFLEXIVE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "IRREFLEXIVE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<=>
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<=>" NULL 2))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "NOT"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ANTISYMMETRIC
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ANTISYMMETRIC" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Z
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?Z" (GET-STELLA-MODULE "/LOGIC" TRUE)
     0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLASS-PROTOTYPE" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CLASS-PROTOTYPE-SPECIALIST" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYNONYM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SYNONYM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TERM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?TERM" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SYNONYM
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?SYNONYM" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ASSERT-SYNONYM-DEMON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "ASSERT-SYNONYM-DEMON" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RETRACT-SYNONYM-DEMON
    (INTERN-RIGID-SYMBOL-WRT-MODULE "RETRACT-SYNONYM-DEMON" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-<=
    (INTERN-RIGID-SYMBOL-WRT-MODULE "<="
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?C2" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?C1" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-FAIL
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FAIL"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/KWD-PL-KERNEL-KB-FORWARD?
    (INTERN-RIGID-SYMBOL-WRT-MODULE "FORWARD?" NULL 2))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB5 ()
  (CL:PROGN
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-TRUE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "TRUE"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CASE-MATCH" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH-RULE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CASE-MATCH-RULE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SOFT-EQ
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SOFT-EQ"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SOFT-EQ-RULE
    (INTERN-RIGID-SYMBOL-WRT-MODULE "SOFT-EQ-RULE" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTEXT-OF" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF-COMPUTATION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CONTEXT-OF-COMPUTATION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-DISJOINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DISJOINT"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CHEAP-DISJOINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "CHEAP-DISJOINT" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-MUTUALLY-DISJOINT-COLLECTION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "MUTUALLY-DISJOINT-COLLECTION"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COVERING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "COVERING" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COVER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?COVER" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DISJOINT-COVERING
    (INTERN-RIGID-SYMBOL-WRT-MODULE "DISJOINT-COVERING" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?DISJOINTCOVER
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?DISJOINTCOVER" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HAS-PARTITION-MEMBERSHIP" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?PROPOSITION" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION1
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?PARTITION1" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION2
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?PARTITION2" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP
    (INTERN-RIGID-SYMBOL-WRT-MODULE "PARTITION-MEMBERSHIP" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-REFUTATION-DISJOINT
    (INTERN-RIGID-SYMBOL-WRT-MODULE "REFUTATION-DISJOINT"
     (GET-STELLA-MODULE "/LOGIC" TRUE) 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFUTATION-DISJOINT-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "REFUTATION-DISJOINT-SPECIALIST" NULL
     0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP-SPECIALIST
    (INTERN-RIGID-SYMBOL-WRT-MODULE "HAS-PARTITION-MEMBERSHIP-SPECIALIST"
     NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION
    (INTERN-RIGID-SYMBOL-WRT-MODULE "?PARTITION" NULL 0))
   (CL:SETQ
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STARTUP-PL-KERNEL-KB
    (INTERN-RIGID-SYMBOL-WRT-MODULE "STARTUP-PL-KERNEL-KB" NULL 0))
   (CL:SETQ /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-METHOD-STARTUP-CLASSNAME
    (INTERN-RIGID-SYMBOL-WRT-MODULE "METHOD-STARTUP-CLASSNAME"
     (GET-STELLA-MODULE "/STELLA" TRUE) 0))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB6 ()
  (CL:PROGN
   (DEFINE-FUNCTION-OBJECT "MEMBER-OF-EVALUATOR"
    "(DEFUN MEMBER-OF-EVALUATOR ((SELF PROPOSITION)))"
    (CL:FUNCTION /PL-KERNEL-KB/MEMBER-OF-EVALUATOR) NULL)
   (DEFINE-FUNCTION-OBJECT "ARITY-COMPUTATION"
    "(DEFUN (ARITY-COMPUTATION INTEGER-WRAPPER) ((DESCRIPTIONARG OBJECT)))"
    (CL:FUNCTION /PL-KERNEL-KB/ARITY-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "ASSERT-SYNONYM-DEMON"
    "(DEFUN ASSERT-SYNONYM-DEMON ((SELF PROPOSITION)))"
    (CL:FUNCTION /PL-KERNEL-KB/ASSERT-SYNONYM-DEMON) NULL)
   (DEFINE-FUNCTION-OBJECT "RETRACT-SYNONYM-DEMON"
    "(DEFUN RETRACT-SYNONYM-DEMON ((SELF PROPOSITION)))"
    (CL:FUNCTION /PL-KERNEL-KB/RETRACT-SYNONYM-DEMON) NULL)
   (DEFINE-FUNCTION-OBJECT "CONTEXT-OF-COMPUTATION"
    "(DEFUN (CONTEXT-OF-COMPUTATION CONTEXT) ((INSTANCE OBJECT)))"
    (CL:FUNCTION /PL-KERNEL-KB/CONTEXT-OF-COMPUTATION) NULL)
   (DEFINE-FUNCTION-OBJECT "INITIALIZE-MODULES"
    "(DEFUN INITIALIZE-MODULES ())"
    (CL:FUNCTION /PL-KERNEL-KB/INITIALIZE-MODULES) NULL)
   (DEFINE-FUNCTION-OBJECT "STARTUP-PL-KERNEL-KB"
    "(DEFUN STARTUP-PL-KERNEL-KB () :PUBLIC? TRUE)"
    (CL:FUNCTION /PL-KERNEL-KB/STARTUP-PL-KERNEL-KB) NULL)
   (CL:LET*
    ((FUNCTION
      (LOOKUP-FUNCTION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STARTUP-PL-KERNEL-KB)))
    (SET-DYNAMIC-SLOT-VALUE (%DYNAMIC-SLOTS FUNCTION)
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-METHOD-STARTUP-CLASSNAME
     (WRAP-STRING "Startup-Pl-Kernel-Kb") NULL-STRING-WRAPPER))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB7 ()
  (CL:PROGN
   (CL:LET* ((SELF-082 (NEW-NAMED-DESCRIPTION)))
    (CL:SETF (%SURROGATE-VALUE-INVERSE SELF-082)
     /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-CLASS)
    (CL:SETF
     (%SURROGATE-VALUE /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-CLASS)
     SELF-082))
   (GET-DESCRIPTION-EXTENSION
    (%SURROGATE-VALUE /PL-KERNEL-KB/SGT-PL-KERNEL-KB-PL-KERNEL-KB-CLASS)
    TRUE)
   (CL:SETQ *WARNIFREDEFINE?* FALSE)
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The class of non-polymorphic unary relations.")))
   (CL:SETQ *WARNIFREDEFINE?* TRUE)
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The class of relations.")))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The class of single-valued relations that can be
used in a term applied to n-1 arguments.")))
   (%DEFOBJECT
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GREATER-OR-EQUAL NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GREATER-OR-EQUAL NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LESS-OR-EQUAL
    NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LESS-OR-EQUAL NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE
    NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
    NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
    NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF NIL))
   (%DEFOBJECT
    /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST NIL))
   (%DEFOBJECT /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
    NIL)
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST NIL))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?A NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?a is an aggregate")))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?c is a collection")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)))
   (%DEFCONCEPT
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE-COLLECTION
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?c is free of duplicates")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE-COLLECTION
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is a set")))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-SET
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is a set of numbers")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-SET NIL)))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?l is a list") /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L NIL)))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GROUP
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE-COLLECTION
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?c is a group")))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STUFF
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is stuff")))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The class of scalar quantities.")))
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR NIL))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR-INTERVAL
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "An interval of scalar quantities. ")))
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR-INTERVAL NIL))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-USER-THING
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The class of user-defined things.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PHRASE
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "A phrase is a variablized sentence, a template, that
is used to express individual axiomatic facts as natural language
sentences.  By convention, a phrase contains one or more occurrences
of each variable in a relation or concept definition, it does not
begin with a capital letter, and it has no concluding period.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?r has phrase ?s")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LEXEME
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is a lexeme for the relation or individual ?r")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "An relation or individual ?r can have zero or more 
lexemes, words that are natural langage equivalents of a logical constant.
The same lexeme may be attached to more than one constant.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMENT
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is a comment attached to ?x.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-DOCUMENTATION
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is a documentation string attached to ?x.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMENT
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-DOCUMENTATION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOCUMENTATION-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ISSUE
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?s is an issue attached to ?x.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMENT
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-EXAMPLE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?E NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?e is an example of (the use of) ?r.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IMAGE-URL
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?URL
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-STRING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?url is a URL pointing to an image illustrating ?x.")))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AUTOMATIC-TERM-INTRODUCTION
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Asserts that first-time references to predication
arguments of type ?c cause automatic introduction of new instances
of ?c.")))
   (%ASSERT
    (LIST*
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AUTOMATIC-TERM-INTRODUCTION
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SP
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'specialist' (a function) that evaluates an (atomic) relation
proposition during query processing.  This defines an extensible
means for computing with the control stack.  The function is passed
a CONTROL-FRAME that contains the proposition, and returns a keyword
:FINAL-SUCCESS, :CONTINUING-SUCCESS, :FAILURE, or :TERMINAL-FAILURE
that controls the result of the computation.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-EVALUATOR
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EV
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names an 'evaluator' (a function) that evaluates an (atomic) relation
proposition during constraint propagation.  This defines an extensible
means for computing using auxiliary data structures.  The function is passed
a proposition for evaluation.  All side-effects are made by updates to
the proposition, or by generating other assertions.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-EVALUATOR
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'computation' (a function) that evaluates an (atomic) relation
proposition during query processing.  The function is passed a proposition
for evaluation for which all arguments are bound.  The function
returns a BOOLEAN if it represents a predicate, or some sort of value
if its a function.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-CONSTRAINT
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'computation' (a function) that evaluates an (atomic) relation
proposition during query processing.  The function is passed a proposition
for evaluation for which all arguments are bound.  The function
returns a BOOLEAN if it represents a predicate, or some sort of value
if its a function.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-CONSTRAINT
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CP
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Very specialized PowerLoom predicate.  Indicates that a computed procedure
used as a relation specialist is programmed to handle reverse
polarity (*reversePolarity?*).")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-TRUE-DEMON
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'computation' (a function) that is attached (logically)
to ?r  Each time a proposition with predicate ?r becomes
true, the function is applied to that proposition.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-TRUE-DEMON NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-UNKNOWN-DEMON
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'computation' (a function) that is attached (logically)
to ?r  Each time a proposition with predicate ?r becomes
unknown, the function is applied to that proposition.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-UNKNOWN-DEMON
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-FALSE-DEMON
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COMPUTATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Names a 'computation' (a function) that is attached (logically)
to ?r  Each time a proposition with predicate ?r becomes
false, the function is applied to that proposition.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-FALSE-DEMON NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Abstract function existing to subsume 'SETOF'
and 'LISTOF'.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF NIL)))))

(CL:DEFUN /PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB8 ()
  (CL:PROGN
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Term-forming function that defines an enumerated set
consisting of all function arguments.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-SETOF NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Term-forming function that defines an ordered list
consisting of all function arguments.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTIONOF NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LISTOF NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if the tuple '?arguments' is a member of the
relation '?relation'.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS-SPECIALIST NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?FUNCTION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?VALUE
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if applying '?function' to '?arguments'
yields the value '?value'.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-SPECIALIST NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CONTEXT
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-CONTEXT NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?P
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if proposition ?p is true in context ?context.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST-SPECIALIST NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IST-SPECIALIST NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Prolog-like CUT.  Succeeds the first time and
then fails.  Side-effect:  Locally disables query optimization.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CUT-SPECIALIST NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
     (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARGUMENTS NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if all arguments are bound.  Used to block
backchaining into unfruitful branches.  Side-effect:
Locally disables query optimization.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES-SPECIALIST
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TEST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?THEN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ELSE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Fail-based conditional.  If ?test succeeds, evaluates
?then; otherwise evaluates ?else.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK-SPECIALIST NIL)))
   (%DEFFUNCTION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-OBSERVED-CARDINALITY-OF
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Used by PowerLoom to record the sizes of class
and relation extensions.  Only filled if the relation extension was
directly accessed by some query.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HIDDEN-RELATION
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Indicates that ?r is used like an internal data
structure; not for user consumption.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-POLYMORPHIC
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if ?r' supports polymorphism")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if ?x is an instance of ?c.  Can
be used to generate class values of ?c, given an instance ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TYPE-OF
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if ?x is an element of ?c.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TYPE-OF NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if ?sub is a subset of ?super.
IMPLEMENTATION NOTE: 'subset-of' is converted internally to an IMPLIES
proposition, i.e., its not an ordinary relation -- it can't have
its own backchaining rules.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?x is a member of collection ?c")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-SPECIALIST
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-SPECIALIST
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-EVALUATOR
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF-EVALUATOR
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-MEMBER
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?x is a member of collection ?c")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-MEMBER
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PORTION-OF
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-AGGREGATE NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-PHRASE
     (WRAP-STRING "?x is a portion of (a piece of) ?y")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TRANSITIVE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PORTION-OF NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOMAIN
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Defines 'domain' for binary relations.  Not normally
asserted for a localized relation (since it would be redundant).")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RANGE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Defines 'range' for binary relations.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NTH-DOMAIN
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if the nth value for a tuple T satisfying
?r must belong to the class ?d. Argument counting starts at one (not at zero).")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NTH-DOMAIN
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R (WRAP-INTEGER 1)
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DOMAIN
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D NIL)
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NTH-DOMAIN
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R (WRAP-INTEGER 2)
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RANGE
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?D NIL)
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SLOT-OF
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "True if the relation ?r is a slot on the instance ?i.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-PHRASE (WRAP-STRING "?c is closed")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "The collection ?c is closed if all of its members are known.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED-SPECIALIST NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED-SPECIALIST NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The relation ?c is single-valued if the value of its
last argument is a function of all other arguments.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED-SPECIALIST
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "The collection ?c is empty if it has no members.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY-SPECIALIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "?c is computed if it can be evaluated only if all of
its input arguments are bound (all of them if its a relation).
Used by the query optimizer when looking for generators.")))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RS
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Function that defines a mapping from a relation
and instance to the skolem that (intensionally) denotes the
corresponding set of role fillers.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-KAPPA
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
       NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?RS NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FILLERS
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEMBERS
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Given a relation ?r and instance ?i, returns
a set of known fillers of ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SETOFALL
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEMBERS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FILLERS NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Function that returns the cardinality of a set.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
      NIL)))
   (%DEFCONCEPT
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Metaclass for frame predicate relations.")))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Relation that specifies a type/range of the relation ?r applied to ?i. ")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FORK
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
         NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
         NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
           NIL)
          NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
           NIL)
          NIL)
         NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERVT NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERVT NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERVT
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TYPE NIL)
          NIL)
         NIL)
        NIL)
       NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VALUE-TYPE-SPECIALIST
       NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?Q
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Function that returns the cardinality of the set
of fillers of the relation ?r applied to ?i.  ")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<<=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
       NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?CARD NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-CARDINALITY NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?Q
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Relation that specifies a lower bound on the cardinality 
of the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<<=
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB
        (LIST*
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-=>>
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LB NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-LOWER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?Q
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Relation that specifies an upper bound on the cardinality 
of the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<<=
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB
        (LIST*
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-=>>
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UB NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CARDINALITY-UPPER-BOUND
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY-SPECIALIST
       NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MINCARD
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Returns the strictest computable lower bound on the
cardinality of the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MINCARD
        (WRAP-INTEGER 1) NIL)
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SETOFALL
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
           (LIST*
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
            NIL)
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M (WRAP-INTEGER 0)
           NIL)
          (LIST*
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FILLERS
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUBR
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUBR
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
             (LIST*
              /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
              (LIST*
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUBR
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
              NIL)
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
            NIL)
           NIL)
          NIL)
         NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MINCARD NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY-SPECIALIST
       NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAXCARD
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Returns the strictest computable upper bound on the
cardinality of the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?V NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAXCARD
        (WRAP-INTEGER 1) NIL)
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SETOFALL
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-OR
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
           (LIST*
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
            NIL)
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
           (LIST*
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M
            (WRAP-INTEGER 1) NIL)
           NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EMPTY
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
            NIL)
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M
            (WRAP-INTEGER 0) NIL)
           NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
           (LIST*
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-CARDINALITY
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
            /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
           NIL)
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR
           (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR NIL)
            (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
             (LIST*
              /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-CARDINALITY
              (LIST*
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUPERR
               /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
              NIL)
             /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?M NIL)
            NIL)
           NIL)
          NIL)
         NIL)
        NIL)
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAXCARD NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
       NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-CARDINALITY-SPECIALIST
       NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-NUMERIC-RANGE
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-SET NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INTERVAL
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTEGER-INTERVAL NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Function that returns an interval representing
the range of allowable numeric values for its members.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SCALAR-INTERVAL
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INTERVAL NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MINIMUM
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Relation that specifies a lower bound on any numeric
value that can belong to the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA->=
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-LOWER-BOUND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-NUMERIC-RANGE
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MINIMUM NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MAXIMUM
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Relation that specifies an upper bound on any numeric
value that can belong to the set of fillers of the relation ?r applied to ?i.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=<
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INTERVAL-UPPER-BOUND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET-NUMERIC-RANGE
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-THE-ROLESET
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?N NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FRAME-PREDICATE
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-NUMERIC-MAXIMUM NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUBRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True iff ?sub is a direct subrelation of ?r; written
in set notation, ?sub < ?r, and there is no ?s such that ?sub < ?s < ?r.
This relation will generate bindings for at most one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUBRELATION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUPERRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True iff ?super is a direct superrelation of ?r;
in set notation, ?super > ?r, and there is no ?s such that ?super > ?s > ?r.
This relation will generate bindings for at most one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUBRELATION NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DIRECT-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUBRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True iff ?sub is a subrelation of ?r; written in set
notation, ?sub =< ?r.  This relation will generate bindings for at most
one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUBRELATION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUPERRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True iff ?super is a superrelation of ?r; written in set
notation, ?super >= ?r.  This relation will generate bindings for at most
one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUBRELATION NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUBRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUB
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True iff ?sub is a proper subrelation of ?r; written in
set notation, ?sub < ?r.  This relation will generate bindings for at most
one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUBRELATION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUPERRELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?SUPER
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "True iff ?super is a proper superrelation of ?r; written in
set notation, ?super > ?r.  This relation will generate bindings for at most
one unbound argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUBRELATION NIL)
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROPER-SUPERRELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
       NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EQUIVALENT-RELATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?EQUIV
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "True if ?r is equivalent to ?equiv; written in set notation,
?r = ?equiv.  This relation will generate bindings for at most one unbound
argument.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-EQUIVALENT-RELATION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-HIERARCHY-SPECIALIST
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-UNION-OF
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UNION
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "True if the union of the collections in ?s
equals ?union.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?UNION NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
        NIL)
       NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
     (CONS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Infer as many members of ?c as possible and
collect them into a STELLA list ?l. ")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECT-INTO-LIST-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?LENGTH
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Computes the length of the list ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LENGTH-OF-LIST NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MIN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the minimum of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-OF-NUMBERS-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MINIMUM-VALUE NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MAX
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the maximum of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-OF-NUMBERS-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MAXIMUM-VALUE NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SUM
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the sum of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM-OF-NUMBERS-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUM NIL)
      NIL)))
   (%DEFFUNCTION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING
      "Project elements in column ?i (zero-based) of the tuples of ?c and
collect them into a STELLA list ?l. ")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST*
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PROJECT-COLUMN-SPECIALIST
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-VALUE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEAN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the mean of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-VALUE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-OF-NUMBERS-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEAN-VALUE NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-VALUE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEDIAN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the median of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-VALUE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-OF-NUMBERS-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEDIAN-VALUE NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEDIAN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the standard deviation of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-STANDARD-DEVIATION NIL)
      NIL)))
   (%DEFRELATION
    (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE
     (LIST*
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?L
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-LIST NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?MEDIAN
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NUMBER NIL)
      NIL)
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
     (WRAP-STRING "Return the variance of the numbers in ?l.")
     /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE-SPECIALIST
       NIL)
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SINGLE-VALUED
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIANCE NIL)
      NIL)))
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
     NIL))
   (%ASSERT
    (LIST*
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
     NIL))
   (%ASSERT
    (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED-PROCEDURE
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
     NIL))
   (%ASSERT
    (LIST*
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HANDLES-REVERSE-POLARITY
     /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONSTRAINT-SPECIALIST
     NIL))))

(CL:DEFUN /PL-KERNEL-KB/STARTUP-PL-KERNEL-KB ()
  (CL:LET*
   ((*MODULE*
     (GET-STELLA-MODULE "/PL-KERNEL-KB" (> *STARTUP-TIME-PHASE* 1)))
    (*CONTEXT* *MODULE*))
   (CL:DECLARE (CL:SPECIAL *MODULE* *CONTEXT*))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 2)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB1)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB2)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB3)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB4)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB5))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 5)
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "INTEGER-INTERVAL"
        "(DEFCLASS INTEGER-INTERVAL (THING) :DOCUMENTATION \"An interval of integers\" :SLOTS ((INTERVAL-LOWER-BOUND :TYPE INTEGER) (INTERVAL-UPPER-BOUND :TYPE INTEGER)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/NEW-INTEGER-INTERVAL))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/ACCESS-INTEGER-INTERVAL-SLOT-VALUE)))
    (CL:LET*
     ((CLASS
       (DEFINE-CLASS-FROM-STRINGIFIED-SOURCE "COMPUTED-PROCEDURE"
        "(DEFCLASS COMPUTED-PROCEDURE (THING) :PUBLIC? TRUE :DOCUMENTATION \"Each instance denotes a programming language 
function that computes some procedure.  The slot 'procedure-name'
provides the name of the procedure.  The slot 'procedure-code'
points directly to the procedure itself.  Both slots are optional;
if neither is supplied, the procedure will be invoked by extracting
its name from the name of the instance.\" :PUBLIC-SLOTS ((PROCEDURE-NAME :TYPE SYMBOL) (PROCEDURE-CODE :TYPE FUNCTION-CODE)))")))
     (CL:SETF (%CLASS-CONSTRUCTOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/NEW-COMPUTED-PROCEDURE))
     (CL:SETF (%CLASS-SLOT-ACCESSOR-CODE CLASS)
      (CL:FUNCTION /PL-KERNEL-KB/ACCESS-COMPUTED-PROCEDURE-SLOT-VALUE))))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 6) (FINALIZE-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 7)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB6))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 8) (FINALIZE-SLOTS)
    (CLEANUP-UNFINALIZED-CLASSES))
   (CL:WHEN (CURRENT-STARTUP-TIME-PHASE? 9)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB7)
    (/PL-KERNEL-KB/HELP-STARTUP-PL-KERNEL-KB8)
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-INTEGER NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING
       "The number of arguments/domains of the relation '?r'.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY-COMPUTATION NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-VARIABLE-ARITY
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Asserts that the relation ?r can take a variable
number of arguments.")))
    (%DEFCONCEPT
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "The class of binary relations.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ARITY
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R (WRAP-INTEGER 2)
       NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INVERSE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INVERSERELATION
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Function that returns the inverse relation for ?r.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INVERSERELATION NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-<=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?INVERSERELATION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DUPLICATE-FREE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "?c is duplicate-free if no two members
denote the same object.")))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ORDERED
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "?c is ordered if the ordering of its
members is significant.")))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMUTATIVE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "A relation ?r is commutative if its truth value is
invariant with any permutation of its arguments.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYMMETRIC
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFLEXIVE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING
       "A binary relation ?r is reflexive if it is always true when
both of its arguments are identical.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-IRREFLEXIVE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING
       "A binary relation ?r is irreflexive if it is false when both
of its arguments are identical.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFLEXIVE
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYMMETRIC
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING
       "A binary relation ?r is symmetric if it is commutative.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMMUTATIVE
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ANTISYMMETRIC
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING
       "A binary relation ?r is antisymmetric if whenever (?r ?x ?y)
is true (?r ?y ?x) is false unless ?x equals ?y.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYMMETRIC
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
          NIL)
         NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
         NIL)
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TRANSITIVE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "A binary relation ?r is transitive if (?r ?x ?y)
and (?r ?y ?z) implies that (?r ?x ?z).")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BINARY-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Z NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Z NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-FUNCTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if the function '?r' is defined for all
combinations of inputs.")))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-ABSTRACT
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?R
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if there are no direct assertions made
to the relation ?r.")))
    (%DEFFUNCTION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Function that, given a class, returns a prototypical
instance that inherits all constraints that apply to any class member,
and has no additional constraints.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE-SPECIALIST
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-TOTAL
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS-PROTOTYPE NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYNONYM
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?TERM
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?SYNONYM NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-PHRASE
      (WRAP-STRING "?synonym is a synonym for ?term")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Assert that ?synonym is a synonym of ?term  This
causes all references to ?synonym to be interpreted as references
to ?term  Retraction eliminates a synonym relation (ignoring
the value of the first arguement.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-TRUE-DEMON
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYNONYM
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-ASSERT-SYNONYM-DEMON
        NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-GOES-UNKNOWN-DEMON
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SYNONYM
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RETRACT-SYNONYM-DEMON
        NIL)
       NIL)))
    (%DEFRULE
     (CONS-LIST
      (WRAP-STRING "'Instance-of' chained with 'subset-of' rule")
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-<=
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-BOUND-VARIABLES
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1 NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
        NIL)
       NIL)))
    (%DEFRULE
     (CONS-LIST (WRAP-STRING "'Not instance-of' rule")
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-<=
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-FAIL
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
         NIL)
        NIL)
       NIL)))
    (%DEFRULE
     (CONS-LIST (WRAP-STRING "Forward 'instance-of' rule")
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-INSTANCE-OF
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HOLDS
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-FORWARD?
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-TRUE))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
       NIL)))
    (%DEFRULE
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH-RULE
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       (LIST*
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CASE-MATCH
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SOFT-EQ
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
       NIL)))
    (%DEFRULE
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SOFT-EQ-RULE
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-FORALL
       (LIST*
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-THING NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-SOFT-EQ
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?Y NIL)
        NIL)
       NIL)))
    (%DEFFUNCTION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF
      (CONS /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?X NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-->
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-CONTEXT NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTED
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-COMPUTATION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF-COMPUTATION
        NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CONTEXT-OF
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COMPUTATION-SPECIALIST
        NIL)
       NIL)))
    (/PL-KERNEL-KB/INITIALIZE-MODULES)
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-DISJOINT
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if the intersection of ?c1 and ?c2 is empty.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-IFF
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1 NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?I
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
         NIL)
        NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CHEAP-DISJOINT
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)))
    (%DEFRELATION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-MUTUALLY-DISJOINT-COLLECTION
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if the members of ?s are pair-wise disjoint.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-=>>
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=>
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-MEMBER-OF
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?S NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
         NIL)
        NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-DISJOINT
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COVERING
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COVER
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if ?c is a subset of the union of all
collections in the set ?cover.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SUBSET-OF
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-UNION-OF
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?COVER NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-DISJOINT-COVERING
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?DISJOINTCOVER
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-SET NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "True if ?c is covered by the collections in
?disjointCover and if ?disjointCover is mutually-disjoint.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COVERING
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?DISJOINTCOVER NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-MUTUALLY-DISJOINT-COLLECTION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?DISJOINTCOVER NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CHEAP-DISJOINT
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Find proof of disjointness without using refutation.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-<<=
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1 NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2 NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-EXISTS
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION1
         /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION2 NIL)
        (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
         (LIST*
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION1 NIL)
         (LIST*
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION
          /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION2 NIL)
         (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-NOT
          (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-=
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION1
           /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION2 NIL)
          NIL)
         NIL)
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-REFUTATION-DISJOINT
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C1
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?C2
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Assume that an instance belongs to both ?c1 and ?c2
and look for a clash.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST*
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-REFUTATION-DISJOINT
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-REFUTATION-DISJOINT-SPECIALIST
       NIL)))
    (%DEFRELATION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
      (CONS
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "TRUE if one or more PARTITION-MEMBERSHIP tuples
exist with ?c as the first argument.  FALSE if none exists.
Unknown if a derivation of PARTITION-MEMBERSHIP tuples has not
occurred.  A specialist for this relation creates PARTITION-MEMBERSHIP
tuples as a side-effect of querying this predicate.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-STELLA-AND
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HIDDEN-RELATION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
        NIL)
       (LIST*
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION-SPECIALIST
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HAS-PARTITION-MEMBERSHIP-SPECIALIST
        NIL)
       NIL)))
    (%DEFRELATION
     (CONS-LIST
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP
      (LIST*
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-?C
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PROPOSITION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-LOGIC-PROPOSITION NIL)
       (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-?PARTITION
        /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-COLLECTION NIL)
       NIL)
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-DOCUMENTATION
      (WRAP-STRING "Caches the fact that ?partition is a partition of
a mutually-disjoint collection, and that ?c is a subset of ?partition.
Used to support rapid computation of pairwise disjointness.")
      /PL-KERNEL-KB/KWD-PL-KERNEL-KB-AXIOMS
      (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-HIDDEN-RELATION
       /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-PARTITION-MEMBERSHIP
       NIL)))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLASS NIL))
    (%ASSERT
     (LIST* /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-CLOSED
      /PL-KERNEL-KB/SYM-PL-KERNEL-KB-PL-KERNEL-KB-RELATION NIL))
    (FINALIZE-RELATIONS))))
